%define __spec_install_post exit 0
Summary: A programming language developed by Ericsson.
Name: erlang
%define version 47.4.1
Version: %{version}
Release: 10
Copyright: EPL
Group: Development/Languages
Source: http://www.erlang.org/download/erlang_base-%{version}.src.tar.bz2
Source1: http://www.erlang.org/download/gs_apps-%{version}.src.tar.bz2
Source2: http://www.erlang.org/download/otp_libs-%{version}.src.tar.bz2
Source3: http://www.erlang.org/download/course.tar.bz2
Source4: http://www.erlang.org/download/erlang-book-part1.pdf
Source5: http://www.erlang.org/download/erlang-book-part1.ps.bz2
Source6: http://www.erlang.org/download/extensions-4.4.pdf
Source7: http://www.erlang.org/download/extensions-4.4.ps.bz2
# The following two patches are required to use eddie
Patch1: erlang.990420-1.diff
Patch2: erlang.990420-2.diff
Patch3: erlang-47.4.1-cases.diff
Patch4: erlang-47.4.1-proto.diff
Patch5: erlang-47.4.1-linux.diff
URL: http://www.erlang.org
Packager: Johan Bevemyr <jb@erix.ericsson.se>
Provides: erlang
BuildRoot: /var/tmp/erlangbuild

%package devel
Summary: Source code for the Erlang base libraries.
Group: Development/Languages
Requires: erlang

%package gs_apps
Summary: The Erlang graphical libraries.
Group: Development/Languages
Provides: erlang-gs_apps
Requires: erlang

%package gs_apps-devel
Summary: Source code for the Erlang graphical libraries.
Group: Development/Languages
Requires: erlang-gs_apps

%package otp_libs
Summary: Application libraries for the Erlang programming language.
Group: Development/Languages
Provides: erlang-otp_libs
Requires: erlang

%package otp_libs-devel
Summary: Source code for the Erlang application libraries.
Group: Development/Languages
Requires: erlang-otp_libs

%package docs
Summary: Documentation for the Erlang language.
Group: Documentation

%description 
Erlang is a programming language developed at Ericsson Computer
Science Laboratory.  Erlang provides many features which are more
commonly associated with an operating system: concurrent processes,
scheduling, memory management, distribution, networking, etc.  This
package includes the Erlang base kit.

%description devel
Erlang is a programming language developed at Ericsson Computer
Science Laboratory.  Erlang provides many features which are more
commonly associated with an operating system: concurrent processes,
scheduling, memory management, distribution, networking, etc.  The
erlang-devel package contains the Erlang sources for all of the base
libraries.

%description gs_apps
Erlang is a programming language developed at Ericsson Computer
Science Laboratory.  Erlang provides many features which are more
commonly associated with an operating system: concurrent processes,
scheduling, memory management, distribution, networking, etc.  This
package contains the Erlang GUI based applications, including the
Erlang GUI system (gs) itself.

%description gs_apps-devel
Erlang is a programming language developed at Ericsson Computer
Science Laboratory.  Erlang provides many features which are more
commonly associated with an operating system: concurrent processes,
scheduling, memory management, distribution, networking, etc.  This
package contains the source code for the Erlang graphical libraries.

%description otp_libs
Erlang is a programming language developed at Ericsson Computer
Science Laboratory.  Erlang provides many features which are more
commonly associated with an operating system: concurrent processes,
scheduling, memory management, distribution, networking, etc.  This
package contains the Erlang application libraries.

%description otp_libs-devel
Erlang is a programming language developed at Ericsson Computer
Science Laboratory.  Erlang provides many features which are more
commonly associated with an operating system: concurrent processes,
scheduling, memory management, distribution, networking, etc.  This
package contains the source code for the Erlang application
libraries.

%description docs
The Erlang/OTP language documentation, including a course in Erlang,
the language description, and a description of some extensions.

%prep

rm -rf $RPM_BUILD_ROOT

%setup -q -n erlang-%{version} -a 1 -a 2
%patch1 -p0
%patch2 -p0
%patch3 -p1 -b .cases
%patch4 -p1 -b .proto
%patch5 -p1 -b .linux

bunzip2 $RPM_SOURCE_DIR/course.tar.bz2
tar xf $RPM_SOURCE_DIR/course.tar
for docfile in erlang-book-part1 extensions-4.4 ; do
  cp $RPM_SOURCE_DIR/$docfile.pdf .
  cp $RPM_SOURCE_DIR/$docfile.ps.bz2 .
done


%build
./configure --prefix=/usr
make beam

make extras EMULATOR=beam

mkdir htmldoc

%install
rm -rf $RPM_BUILD_ROOT
######################################################################
# First install only base

make install EMULATOR=beam INSTALL_PREFIX=$RPM_BUILD_ROOT EXTRAS=
gzip $RPM_BUILD_ROOT/usr/man/*/*[!.gz] || :
gzip $RPM_BUILD_ROOT/usr/lib/erlang/man/*/*[!.gz] || :
########################################
# Find out which files belong to base and 
# devel of base
#

cd $RPM_BUILD_ROOT

# first extract any html documentation and move them to htmldoc

cd usr/lib/erlang

find . -name "*.html" -o -name "*.gif" > \
	$RPM_BUILD_DIR/erlang-%{version}/htmlfiles

tar cf - -T $RPM_BUILD_DIR/erlang-%{version}/htmlfiles | \
	(cd $RPM_BUILD_DIR/erlang-%{version}/htmldoc ; tar xf -)

find . \( -name "*.html" -o -name "*.gif" \) -printf "rm -f %%P\n" | sh

cd ../../../


# then find out which files we need for the package

find usr \( ! -type d ! -name "*.erl" ! -name "*.html" ! -name "*.gif" !\
	-name "*.[1-9]" ! -name "README" \) -printf "/usr/%%P\n" >\
	$RPM_BUILD_DIR/erlang-%{version}/files.base

find usr \( \( -name "*.html" -o -name "*.gif" -o -name "README" -o \
	-name "*.[1-9]" \) -and ! \
	-type d \) -printf "%%%%doc /usr/%%P\n" >> \
	$RPM_BUILD_DIR/erlang-%{version}/files.base

find usr \( -name "*.erl" -and ! -type d \) -printf "/usr/%%P\n" > \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.devel

cd $RPM_BUILD_DIR/erlang-%{version}

######################################################################
# Second install otp_libs

make install.extras EMULATOR=beam INSTALL_PREFIX=$RPM_BUILD_ROOT EXTRAS=otp

gzip $RPM_BUILD_ROOT/usr/man/*/*[!.gz] || :
gzip $RPM_BUILD_ROOT/usr/lib/erlang/man/*/*[!.gz] || :

########################################
# Find out which files belong to base and 
# devel of base
#

cd $RPM_BUILD_ROOT

# first extract any html documentation and move them to htmldoc

cd usr/lib/erlang

find . -name "*.html" -o -name "*.gif" > \
	$RPM_BUILD_DIR/erlang-%{version}/htmlfiles.otp

tar cf - -T $RPM_BUILD_DIR/erlang-%{version}/htmlfiles.otp | \
	(cd $RPM_BUILD_DIR/erlang-%{version}/htmldoc ; tar xf -)

find . \( -name "*.html" -o -name "*.gif" \) -printf "rm -f %%P\n" | sh

cd ../../../

# then find out which files we need

find usr \( ! -type d ! -name "*.erl" ! -name "*.html" ! -name "*.gif" ! \
	-name "*.[1-9]" ! -name "README" \) -printf "/usr/%%P\n" > \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.otp

find usr \( \( -name "*.html" -o -name "*.gif" -o -name "README" \
	-o -name "*.[1-9]" \) -and ! \
	-type d \) -printf "%%%%doc /usr/%%P\n" >> \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.otp

find usr \( -name "*.erl" -and ! -type d \) -printf "/usr/%%P\n" > \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.otp.devel

cd $RPM_BUILD_DIR/erlang-%{version}

####################################################################
# Finally install gs_apps

make install.extras EMULATOR=beam INSTALL_PREFIX=$RPM_BUILD_ROOT EXTRAS=gs_apps
gzip $RPM_BUILD_ROOT/usr/man/*/*[!.gz] || :
gzip $RPM_BUILD_ROOT/usr/lib/erlang/man/*/*[!.gz] || :
########################################
# Find out which files belong to base and 
# devel of base
#

cd $RPM_BUILD_ROOT

# first extract any html documentation and move them to htmldoc

cd usr/lib/erlang

find . -name "*.html" -o -name "*.gif" > \
	$RPM_BUILD_DIR/erlang-%{version}/htmlfiles.gs

tar cf - -T $RPM_BUILD_DIR/erlang-%{version}/htmlfiles.gs | \
	(cd $RPM_BUILD_DIR/erlang-%{version}/htmldoc ; tar xf -)

find . \( -name "*.html" -o -name "*.gif" \) -printf "rm -f %%P\n" | sh

cd ../../../

# then find out which files we need

find usr \( ! -type d ! -name "*.erl" ! -name "*.html" ! -name "*.gif" ! \
	-name "*.[1-9]" ! -name "README" \) -printf "/usr/%%P\n" > \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.otp.gs

find usr \( \( -name "*.html" -o -name "*.gif" -o -name "README" \
	-o -name "*.[1-9]" \) -and ! \
	-type d \) -printf "%%%%doc /usr/%%P\n" >> \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.otp.gs

find usr \( -name "*.erl" -and ! -type d \) -printf "/usr/%%P\n" > \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.otp.gs.devel

######################################################################
#
# calculate which files belong to which package
#

comm -1 -3 $RPM_BUILD_DIR/erlang-%{version}/files.base \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.otp > \
	$RPM_BUILD_DIR/erlang-%{version}/files.otp

comm -1 -3 $RPM_BUILD_DIR/erlang-%{version}/files.base.devel \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.otp.devel > \
	$RPM_BUILD_DIR/erlang-%{version}/files.otp.devel

comm -1 -3 $RPM_BUILD_DIR/erlang-%{version}/files.base.otp \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.otp.gs > \
	$RPM_BUILD_DIR/erlang-%{version}/files.gs

comm -1 -3 $RPM_BUILD_DIR/erlang-%{version}/files.base.otp.devel \
	$RPM_BUILD_DIR/erlang-%{version}/files.base.otp.gs.devel > \
	$RPM_BUILD_DIR/erlang-%{version}/files.gs.devel

%clean

rm -rf $RPM_BUILD_ROOT

%files -f files.base
%defattr(-,root,root)
%doc README

%files devel -f files.base.devel
%defattr(-,root,root)
%doc README
%doc doc
%doc htmldoc

%files otp_libs -f files.otp
%defattr(-,root,root)
%doc README
 
%files otp_libs-devel -f files.otp.devel
%defattr(-,root,root)
%doc README

%files gs_apps -f files.gs
%defattr(-,root,root)
%doc README

%files gs_apps-devel -f files.gs.devel
%defattr(-,root,root)
%doc README

%files docs
%defattr(-,root,root)
%doc course
%doc erlang-book-part1.pdf
%doc erlang-book-part1.ps.gz
%doc extensions-4.4.pdf
%doc extensions-4.4.ps.gz

%changelog
* Fri Feb 04 2000 Tim Powers <timp@redhat.com>
- fixed so that *all* man pages are gzip'ed, not just the man pages in
	/usr/man
- removed vendor tag

* Tue Jan 18 2000 Tim Powers <timp@redhat.com>
- bzip sources that were gzipped to conserve space.

* Fri Jan 7 2000 Tim Powers <timp@redhat.com>
- rebuilt for 6.2
- gzip manpages

* Tue Aug 17 1999 Tim Powers <timp@redhat.com>
- fixed install, now installs under /usr instead of /usr/local

* Tue Jul 13 1999 Tim Powers <timp@redhat.com>
- rebuilt for 6.1

* Tue May 11 1999 Cristian Gafton <gafton@redhat.com>
- use %defattr in all packages

* Wed May 05 1999 Michael K. Johnson <johnsonm@redhat.com>
- added the erlang-docs subpackage

* Sun May 02 1999 Michael K. Johnson <johnsonm@redhat.com>
- included patches for eddie
- built for powertools
